"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeConditionExpression = exports.isIn = exports.between = exports.contains = exports.beginsWith = exports.attributeType = exports.size = exports.attributeNotExists = exports.attributeExists = exports.OR = exports.AND = exports.NOT = void 0;
var dynamodb_expressions_1 = require("@awslabs-community-fork/dynamodb-expressions");
// eslint-disable-next-line functional/prefer-readonly-type
var comparatorOperators = [
    '=',
    '<',
    '<=',
    '>',
    '>=',
    '<>',
];
var isComparator = function (a) {
    var keys = Object.keys(a);
    return (keys.length === 1 &&
        comparatorOperators.includes(keys[0]));
};
var NOT = function () {
    // eslint-disable-next-line functional/functional-parameters
    var expressions = [];
    for (
    // eslint-disable-next-line functional/functional-parameters
    var _i = 0; 
    // eslint-disable-next-line functional/functional-parameters
    _i < arguments.length; 
    // eslint-disable-next-line functional/functional-parameters
    _i++) {
        // eslint-disable-next-line functional/functional-parameters
        expressions[_i] = arguments[_i];
    }
    return ({
        __type: 'boolean_combinator',
        combinator: 'NOT',
        expressions: expressions,
    });
};
exports.NOT = NOT;
var AND = function () {
    // eslint-disable-next-line functional/functional-parameters
    var expressions = [];
    for (
    // eslint-disable-next-line functional/functional-parameters
    var _i = 0; 
    // eslint-disable-next-line functional/functional-parameters
    _i < arguments.length; 
    // eslint-disable-next-line functional/functional-parameters
    _i++) {
        // eslint-disable-next-line functional/functional-parameters
        expressions[_i] = arguments[_i];
    }
    return ({
        __type: 'boolean_combinator',
        combinator: 'AND',
        expressions: expressions,
    });
};
exports.AND = AND;
var OR = function () {
    // eslint-disable-next-line functional/functional-parameters
    var expressions = [];
    for (
    // eslint-disable-next-line functional/functional-parameters
    var _i = 0; 
    // eslint-disable-next-line functional/functional-parameters
    _i < arguments.length; 
    // eslint-disable-next-line functional/functional-parameters
    _i++) {
        // eslint-disable-next-line functional/functional-parameters
        expressions[_i] = arguments[_i];
    }
    return ({
        __type: 'boolean_combinator',
        combinator: 'OR',
        expressions: expressions,
    });
};
exports.OR = OR;
var attributeExists = function () { return ({
    __type: 'function',
    function: 'attribute_exists',
}); };
exports.attributeExists = attributeExists;
var attributeNotExists = function () { return ({
    __type: 'function',
    function: 'attribute_not_exists',
}); };
exports.attributeNotExists = attributeNotExists;
var size = function (c) { return ({
    __type: 'function',
    function: 'size',
    comparator: c,
}); };
exports.size = size;
var attributeType = function (v) { return ({
    __type: 'function',
    function: 'attribute_type',
    arg: v,
}); };
exports.attributeType = attributeType;
var beginsWith = function (v) { return ({
    __type: 'function',
    function: 'begins_with',
    arg: v,
}); };
exports.beginsWith = beginsWith;
var contains = function (v) { return ({
    __type: 'function',
    function: 'contains',
    arg: v,
}); };
exports.contains = contains;
var between = function (lower, upper) { return ({
    __type: 'function',
    function: 'between',
    lower: lower,
    upper: upper,
}); };
exports.between = between;
var isIn = function (values) { return ({
    __type: 'function',
    function: 'in',
    values: values,
}); };
exports.isIn = isIn;
var isInFunction = function (exp) {
    return exp.__type === 'function' &&
        exp.function === 'in';
};
var isBetweenFunction = function (exp) {
    return exp.__type === 'function' &&
        exp.function === 'between';
};
var isSizeFunction = function (exp) {
    return exp.__type === 'function' &&
        exp.function === 'size';
};
var isComparisonFunction = function (exp) {
    return exp.__type === 'function';
};
var isComparisonFunctionWithArg = function (exp) {
    return exp.__type === 'function' &&
        !!exp.arg;
};
var isCombinator = function (exp) {
    return exp.__type === 'boolean_combinator';
};
var serializeComparator = function (c, attributes) { return "".concat(Object.keys(c)[0], " ").concat(attributes.addValue(Object.values(c)[0])); };
var _serializeConditionExpression = function (
// eslint-disable-next-line @typescript-eslint/no-explicit-any
expression, attributes, path, combinator) {
    if (combinator === void 0) { combinator = 'AND'; }
    if (isCombinator(expression)) {
        if (expression.combinator === 'NOT') {
            return "NOT (".concat(_serializeConditionExpression(expression.expressions, attributes, path), ")");
        }
        else {
            return _serializeConditionExpression(expression.expressions, attributes, path, expression.combinator);
        }
    }
    else if (Array.isArray(expression)) {
        var _a = __read(expression), head = _a[0], tail = _a.slice(1);
        return tail.reduce(function (p, n) {
            return "".concat(p, " ").concat(combinator, " ").concat(_serializeConditionExpression(n, attributes, path, combinator));
        }, _serializeConditionExpression(head, attributes, path, combinator));
    }
    else {
        var keys = Object.keys(expression);
        var expressions = keys.map(function (key) {
            var attributePath = new dynamodb_expressions_1.AttributePath(__spreadArray(__spreadArray([], __read(path.elements), false), [
                { type: 'AttributeName', name: key },
            ], false));
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            var queryObject = expression;
            var operator = queryObject[key];
            if (isBetweenFunction(operator)) {
                return "".concat(attributes.addName(attributePath), " BETWEEN ").concat(attributes.addValue(operator.lower), " AND ").concat(attributes.addValue(operator.upper));
            }
            else if (isInFunction(operator)) {
                return "".concat(attributes.addName(attributePath), " in (").concat(operator.values
                    .map(function (a) { return attributes.addValue(a); })
                    .join(', '), ")");
            }
            else if (!!operator && isComparator(operator)) {
                return "".concat(attributes.addName(attributePath), " ").concat(serializeComparator(operator, attributes));
            }
            else if (isComparisonFunctionWithArg(operator)) {
                return "".concat(operator.function, " (").concat(attributes.addName(attributePath), ", ").concat(attributes.addValue(operator.arg), ")");
            }
            else if (isSizeFunction(operator)) {
                return "size (".concat(attributes.addName(attributePath), ") ").concat(serializeComparator(operator.comparator, attributes));
            }
            else if (isComparisonFunction(operator)) {
                return "".concat(operator.function, " (").concat(attributes.addName(attributePath), ")");
            }
            else if (typeof operator === 'object') {
                return _serializeConditionExpression(
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                operator, attributes, attributePath);
            }
            else {
                // eslint-disable-next-line functional/no-throw-statement
                throw new Error("Unknown expression ".concat(JSON.stringify(expression)));
            }
        });
        var _b = __read(expressions), head = _b[0], tail = _b.slice(1);
        return tail.reduce(function (p, n) { return "(".concat(p, ") ").concat(combinator, " (").concat(n, ")"); }, head);
    }
};
var serializeConditionExpression = function (
// eslint-disable-next-line @typescript-eslint/no-explicit-any
expression, attributes) {
    return expression &&
        _serializeConditionExpression(expression, attributes, new dynamodb_expressions_1.AttributePath([]));
};
exports.serializeConditionExpression = serializeConditionExpression;
