"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
var table_builder_1 = require("./table-builder");
describe('tableBuilder', function () {
    it('should buid a table', function () {
        var tb = (0, table_builder_1.tableBuilder)('Mytable');
        var builder = tb
            .withKey('partition', 'sort')
            .withGlobalIndex('gsi_by_gsip', 'gsip', 'gsis')
            .withLocalIndex('local', 'lsis');
        var tableDef = builder._debug();
        expect(tableDef).toMatchObject({
            indexes: {
                gsi_by_gsip: {
                    name: 'gsi_by_gsip',
                    indexType: 'global',
                    partitionKey: 'gsip',
                    sortKey: 'gsis',
                },
                local: {
                    name: 'local',
                    indexType: 'local',
                    partitionKey: 'partition',
                    sortKey: 'lsis',
                },
            },
            name: 'Mytable',
            partitionKey: 'partition',
            sortKey: 'sort',
        });
    });
});
